#ifndef _H_9CDAB3E6BF5FF817DF2117DD28A330A3_Status_DCPS_H_
#define _H_9CDAB3E6BF5FF817DF2117DD28A330A3_Status_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "Status_.h"


namespace urg_node_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class Status_TypeSupportInterface;

            typedef Status_TypeSupportInterface * Status_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Status_TypeSupportInterface> Status_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Status_TypeSupportInterface> Status_TypeSupportInterface_out;


            class Status_DataWriter;

            typedef Status_DataWriter * Status_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Status_DataWriter> Status_DataWriter_var;
            typedef DDS_DCPSInterface_out < Status_DataWriter> Status_DataWriter_out;


            class Status_DataReader;

            typedef Status_DataReader * Status_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Status_DataReader> Status_DataReader_var;
            typedef DDS_DCPSInterface_out < Status_DataReader> Status_DataReader_out;


            class Status_DataReaderView;

            typedef Status_DataReaderView * Status_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Status_DataReaderView> Status_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Status_DataReaderView> Status_DataReaderView_out;

            struct Status_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < Status_, struct Status_Seq_uniq_> Status_Seq;
            typedef DDS_DCPSSequence_var < Status_Seq> Status_Seq_var;
            typedef DDS_DCPSSequence_out < Status_Seq> Status_Seq_out;

            class  Status_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Status_TypeSupportInterface_ptr _ptr_type;
                typedef Status_TypeSupportInterface_var _var_type;

                static Status_TypeSupportInterface_ptr _duplicate (Status_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Status_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Status_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Status_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Status_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Status_TypeSupportInterface () {};
                ~Status_TypeSupportInterface () {};
            private:
                Status_TypeSupportInterface (const Status_TypeSupportInterface &);
                Status_TypeSupportInterface & operator = (const Status_TypeSupportInterface &);
            };

            class  Status_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Status_DataWriter_ptr _ptr_type;
                typedef Status_DataWriter_var _var_type;

                static Status_DataWriter_ptr _duplicate (Status_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Status_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Status_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Status_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Status_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Status_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Status_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Status_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Status_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Status_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Status_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Status_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Status_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Status_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Status_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Status_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Status_& instance_data) = 0;

            protected:
                Status_DataWriter () {};
                ~Status_DataWriter () {};
            private:
                Status_DataWriter (const Status_DataWriter &);
                Status_DataWriter & operator = (const Status_DataWriter &);
            };

            class  Status_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Status_DataReader_ptr _ptr_type;
                typedef Status_DataReader_var _var_type;

                static Status_DataReader_ptr _duplicate (Status_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Status_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Status_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Status_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Status_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Status_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Status_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Status_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Status_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Status_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Status_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Status_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Status_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Status_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Status_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Status_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Status_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Status_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Status_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Status_& instance) = 0;

            protected:
                Status_DataReader () {};
                ~Status_DataReader () {};
            private:
                Status_DataReader (const Status_DataReader &);
                Status_DataReader & operator = (const Status_DataReader &);
            };

            class  Status_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Status_DataReaderView_ptr _ptr_type;
                typedef Status_DataReaderView_var _var_type;

                static Status_DataReaderView_ptr _duplicate (Status_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Status_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Status_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Status_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Status_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Status_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Status_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Status_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Status_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Status_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Status_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Status_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Status_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Status_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Status_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Status_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Status_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Status_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Status_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Status_& instance) = 0;

            protected:
                Status_DataReaderView () {};
                ~Status_DataReaderView () {};
            private:
                Status_DataReaderView (const Status_DataReaderView &);
                Status_DataReaderView & operator = (const Status_DataReaderView &);
            };
        }

    }

}

#endif
